(*------------------------------------------------------------
   HELLOWIN.C   --   Displays "Hello, Windows 95!" in client area
                 (C) Charles Petzold, 1996
   HELLOWIN.MOD --   Translation to SB Modula2
                 (C) Peter Stadler,  14.02.1997
  ------------------------------------------------------------*)


MODULE HelloWin;

IMPORT SYSTEM;
IMPORT WIN32;
IMPORT WINUSER;
IMPORT WINGDI;
IMPORT WINX;
IMPORT MMSYSTEM;

CONST AppName = "HelloWin";
(*
      Title   = AppName + " Application";*)

VAR  hwnd       : WIN32.HWND;
     msg        : WINUSER.MSG;
     wc         : WINUSER.WNDCLASSEX;
     (*
     iCmdShow   : INTEGER;*)

<*/PUSH*>
%IF WIN32 %THEN
    <*/CALLS:WIN32SYSTEM*>
%ELSE
    <*/CALLS:WINSYSTEM*>
%END
PROCEDURE WndProc (hwnd        : WIN32.HWND;
                   iMsg        : WIN32.UINT;
                   wParam      : WIN32.WPARAM;
                   lParam      : WIN32.LPARAM) : WIN32.LRESULT [EXPORT];
  VAR
     hdc     :   WIN32.HDC;
     ps      :   WINUSER.PAINTSTRUCT;
     rect    :   WIN32.RECT;
     hBrush  :   WIN32.HBRUSH;
BEGIN
  CASE iMsg OF
  | WINUSER.WM_CREATE:
      SYSTEM.FUNC MMSYSTEM.PlaySound ("hellowin.wav", NIL, MMSYSTEM.SND_FILENAME + MMSYSTEM.SND_ASYNC);
      RETURN 0;

  | WINUSER.WM_PAINT:
      hdc := WINUSER.BeginPaint (hwnd,ps);
      hBrush := WINGDI.CreateSolidBrush(WINGDI.RGB(0,0,255));
      SYSTEM.FUNC WINUSER.GetClientRect (hwnd, rect);
      SYSTEM.FUNC WINUSER.FillRect(hdc,rect,hBrush);
      SYSTEM.FUNC WINUSER.DrawText (hdc, "Hello, Windows 95!", -1, rect,
                                  WINUSER.DT_SINGLELINE + WINUSER.DT_CENTER + WINUSER.DT_VCENTER);
      SYSTEM.FUNC WINUSER.EndPaint (hwnd, ps);
      RETURN 0;

  | WINUSER.WM_DESTROY:
      WINUSER.PostQuitMessage(0);
      RETURN 0;
  ELSE
    RETURN WINUSER.DefWindowProc (hwnd, iMsg, wParam, lParam);
  END;
END WndProc;
<*/POP*>
PROCEDURE InitApplication () : BOOLEAN;
BEGIN
   wc.cbSize        := SIZE(WINUSER.WNDCLASSEX);
   wc.style         := WINUSER.CS_HREDRAW BOR WINUSER.CS_VREDRAW;
   wc.lpfnWndProc   := SYSTEM.CAST(WINUSER.WNDPROC,WndProc);
   wc.cbClsExtra    := 0;
   wc.cbWndExtra    := 0;
   wc.hInstance     := WINX.Instance;
   wc.hIcon         := WINUSER.LoadIcon (NIL, WINUSER.IDI_APPLICATION^);
   wc.hCursor       := WINUSER.LoadCursor (NIL, WINUSER.IDC_ARROW^);
   wc.hbrBackground := SYSTEM.CAST(WIN32.HBRUSH, WINGDI.GetStockObject (WINGDI.WHITE_BRUSH));
   wc.lpszMenuName  := NIL;
   wc.lpszClassName := SYSTEM.ADR (AppName);
   wc.hIconSm       := WINUSER.LoadIcon (NIL, WINUSER.IDI_APPLICATION^);

   RETURN WINUSER.RegisterClassEx (wc) <> 0;
END InitApplication;

PROCEDURE InitMainWindow() : BOOLEAN;
BEGIN
  hwnd := WINUSER.CreateWindow (AppName,                        (* window class name            *)
                                "The Hello Program",            (* window caption               *)
                                WINUSER.WS_OVERLAPPEDWINDOW,    (* window style                 *)
                                WINUSER.CW_USEDEFAULT,          (* initial x position           *)
                                WINUSER.CW_USEDEFAULT,          (* initial y position           *)
                                WINUSER.CW_USEDEFAULT,          (* initial x size               *)
                                WINUSER.CW_USEDEFAULT,          (* initial y size               *)
                                NIL,                            (* parent window handle         *)
                                NIL,                            (* window menu handle           *)
                                wc.hInstance,                   (* program instance handle      *)
                                NIL);                           (* creation parameters          *)

  SYSTEM.FUNC WINUSER.ShowWindow   (hwnd, WINUSER.SW_SHOWDEFAULT);
(*
  WIN32.ShowWindow (hwnd, SYSTEM.CAST(WIN32.SW_ENUM,iCmdShow));
*)
  SYSTEM.FUNC WINUSER.UpdateWindow (hwnd);

  RETURN TRUE;
END InitMainWindow;


BEGIN
  IF InitApplication() AND InitMainWindow() THEN
    WHILE (WINUSER.GetMessage(msg,NIL,0,0)) DO
      SYSTEM.FUNC WINUSER.TranslateMessage(msg);
      SYSTEM.FUNC WINUSER.DispatchMessage(msg);
    END;
  END;
(*
  RETURN msg.wParam;
*)
END HelloWin.
